/*
 * Copyright (C) 2017 Laboratoire ThéMA - UMR 6049 - CNRS / Université de Franche-Comté
 * http://thema.univ-fcomte.fr
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */


package org.thema.modaccess;

import org.locationtech.jts.geom.Coordinate;
import org.locationtech.jts.geom.Envelope;
import org.locationtech.jts.geom.Geometry;
import org.locationtech.jts.geom.GeometryFactory;
import org.locationtech.jts.geom.Polygon;
import org.locationtech.jts.operation.union.CascadedPolygonUnion;
import org.locationtech.jts.triangulate.VoronoiDiagramBuilder;
import java.awt.Color;
import java.awt.GraphicsEnvironment;
import java.awt.HeadlessException;
import java.awt.SplashScreen;
import java.awt.event.ActionEvent;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.Writer;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.ResourceBundle;
import java.util.TreeMap;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.AbstractAction;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.JPopupMenu;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import org.apache.commons.math3.stat.descriptive.SummaryStatistics;
import org.thema.modaccess.tools.Tools;
import org.thema.network.AbstractNetwork;
import org.thema.network.data.Stop;
import org.thema.network.WeightNetwork;
import org.thema.network.data.NodeProperties;
import org.thema.network.TimeTableNetwork;
import org.geotools.graph.structure.Edge;
import org.geotools.graph.structure.Graph;
import org.thema.common.Config;
import org.thema.common.DayTime;
import org.thema.common.JavaLoader;
import org.thema.common.ProgressBar;
import org.thema.common.Util;
import org.thema.common.collection.HashMapList;
import org.thema.common.swing.TaskMonitor;
import org.thema.common.swing.PreferencesDialog;
import org.thema.data.feature.DefaultFeature;
import org.thema.data.feature.Feature;
import org.thema.data.IOFeature;
import org.thema.drawshape.layer.DefaultGroupLayer;
import org.thema.drawshape.layer.FeatureLayer;
import org.thema.drawshape.layer.Layer;
import org.thema.drawshape.style.FeatureStyle;
import org.thema.drawshape.style.PointStyle;
import org.thema.drawshape.ui.MapViewer;
import org.thema.graph.shape.GraphLayer;
import org.thema.network.GraphNetworkFactory;
import org.thema.network.InterNetwork;
import org.thema.network.Network.Mode;
import org.thema.network.NetworkLocation;
import org.thema.network.dijkstra.DefaultWeighter;
import org.thema.network.dijkstra.DijkstraNetworkPathFinder;
import org.thema.network.dijkstra.NetworkPathFinder;
import org.thema.network.dijkstra.ReverseDijkstraNetworkPathFinder;

/**
 *
 * @author Gilles Vuidel
 */
public class MainFrame extends javax.swing.JFrame {
    
    private Project project;

    /** Creates new form MainFrame */
    public MainFrame() {
        initComponents();
        setLocationRelativeTo(null);
        setTitle(ResourceBundle.getBundle("org/thema/modaccess/Bundle").getString("MainFrame.title") + " - " + JavaLoader.getVersion(MainFrame.class));
        project = new Project();
        mapViewer.putAddLayerButton();
        mapViewer.putExportButton();
        Config.setProgressBar(mapViewer.getProgressBar());
    }

    public MapViewer getMapViewer() {
        return mapViewer;
    }

    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        mapViewer = new org.thema.drawshape.ui.MapViewer();
        MenuBar = new javax.swing.JMenuBar();
        fileMenu = new javax.swing.JMenu();
        loadTCNetMenuItem = new javax.swing.JMenuItem();
        loadNetMenuItem = new javax.swing.JMenuItem();
        loadProjectjMenuItem = new javax.swing.JMenuItem();
        saveProjectMenuItem = new javax.swing.JMenuItem();
        jSeparator1 = new javax.swing.JSeparator();
        prefMenuItem = new javax.swing.JMenuItem();
        pathMenu = new javax.swing.JMenu();
        odMatrixMenuItem = new javax.swing.JMenuItem();
        odMatrixShpMenuItem = new javax.swing.JMenuItem();
        srcPathMenuItem = new javax.swing.JMenuItem();
        pathMenuItem = new javax.swing.JMenuItem();
        nearestResMenuItem = new javax.swing.JMenuItem();
        toolMenu = new javax.swing.JMenu();
        createBDMenuItem = new javax.swing.JMenuItem();
        createBDStationMenuItem = new javax.swing.JMenuItem();
        jSeparator2 = new javax.swing.JPopupMenu.Separator();
        checkTCNetMenuItem = new javax.swing.JMenuItem();
        checkPartMenuItem = new javax.swing.JMenuItem();
        checkAllPathMenuItem = new javax.swing.JMenuItem();
        jSeparator3 = new javax.swing.JPopupMenu.Separator();
        sinuositeMenuItem = new javax.swing.JMenuItem();
        splitLineMenuItem = new javax.swing.JMenuItem();
        affectBusMenuItem = new javax.swing.JMenuItem();
        mergeLinesMenuItem = new javax.swing.JMenuItem();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("org/thema/modaccess/Bundle"); // NOI18N
        setTitle(bundle.getString("MainFrame.title")); // NOI18N

        mapViewer.setTreeLayerVisible(true);

        fileMenu.setText(bundle.getString("MainFrame.fileMenu.text")); // NOI18N

        loadTCNetMenuItem.setText(bundle.getString("MainFrame.loadTCNetMenuItem.text")); // NOI18N
        loadTCNetMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                loadTCNetMenuItemActionPerformed(evt);
            }
        });
        fileMenu.add(loadTCNetMenuItem);

        loadNetMenuItem.setText(bundle.getString("MainFrame.loadNetMenuItem.text")); // NOI18N
        loadNetMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                loadNetMenuItemActionPerformed(evt);
            }
        });
        fileMenu.add(loadNetMenuItem);

        loadProjectjMenuItem.setText(bundle.getString("MainFrame.loadProjectjMenuItem.text")); // NOI18N
        loadProjectjMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                loadProjectjMenuItemActionPerformed(evt);
            }
        });
        fileMenu.add(loadProjectjMenuItem);

        saveProjectMenuItem.setText(bundle.getString("MainFrame.saveProjectMenuItem.text")); // NOI18N
        saveProjectMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                saveProjectMenuItemActionPerformed(evt);
            }
        });
        fileMenu.add(saveProjectMenuItem);
        fileMenu.add(jSeparator1);

        prefMenuItem.setText(bundle.getString("MainFrame.prefMenuItem.text")); // NOI18N
        prefMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                prefMenuItemActionPerformed(evt);
            }
        });
        fileMenu.add(prefMenuItem);

        MenuBar.add(fileMenu);

        pathMenu.setText(bundle.getString("MainFrame.pathMenu.text")); // NOI18N

        odMatrixMenuItem.setText(bundle.getString("MainFrame.odMatrixMenuItem.text")); // NOI18N
        odMatrixMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                odMatrixMenuItemActionPerformed(evt);
            }
        });
        pathMenu.add(odMatrixMenuItem);

        odMatrixShpMenuItem.setText(bundle.getString("MainFrame.odMatrixShpMenuItem.text")); // NOI18N
        odMatrixShpMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                odMatrixShpMenuItemActionPerformed(evt);
            }
        });
        pathMenu.add(odMatrixShpMenuItem);

        srcPathMenuItem.setText(bundle.getString("MainFrame.srcPathMenuItem.text")); // NOI18N
        srcPathMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                srcPathMenuItemActionPerformed(evt);
            }
        });
        pathMenu.add(srcPathMenuItem);

        pathMenuItem.setText(bundle.getString("MainFrame.pathMenuItem.text")); // NOI18N
        pathMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                pathMenuItemActionPerformed(evt);
            }
        });
        pathMenu.add(pathMenuItem);

        nearestResMenuItem.setText(bundle.getString("MainFrame.nearestResMenuItem.text")); // NOI18N
        nearestResMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                nearestResMenuItemActionPerformed(evt);
            }
        });
        pathMenu.add(nearestResMenuItem);

        MenuBar.add(pathMenu);

        toolMenu.setText(bundle.getString("MainFrame.toolMenu.text")); // NOI18N

        createBDMenuItem.setText(bundle.getString("MainFrame.createBDMenuItem.text")); // NOI18N
        createBDMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                createBDMenuItemActionPerformed(evt);
            }
        });
        toolMenu.add(createBDMenuItem);

        createBDStationMenuItem.setText(bundle.getString("MainFrame.createBDStationMenuItem.text")); // NOI18N
        createBDStationMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                createBDStationMenuItemActionPerformed(evt);
            }
        });
        toolMenu.add(createBDStationMenuItem);
        toolMenu.add(jSeparator2);

        checkTCNetMenuItem.setText(bundle.getString("MainFrame.checkTCNetMenuItem.text")); // NOI18N
        checkTCNetMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                checkTCNetMenuItemActionPerformed(evt);
            }
        });
        toolMenu.add(checkTCNetMenuItem);

        checkPartMenuItem.setText(bundle.getString("MainFrame.checkPartMenuItem.text")); // NOI18N
        checkPartMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                checkPartMenuItemActionPerformed(evt);
            }
        });
        toolMenu.add(checkPartMenuItem);

        checkAllPathMenuItem.setText(bundle.getString("MainFrame.checkAllPathMenuItem.text")); // NOI18N
        checkAllPathMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                checkAllPathMenuItemActionPerformed(evt);
            }
        });
        toolMenu.add(checkAllPathMenuItem);
        toolMenu.add(jSeparator3);

        sinuositeMenuItem.setText(bundle.getString("MainFrame.sinuositeMenuItem.text")); // NOI18N
        sinuositeMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                sinuositeMenuItemActionPerformed(evt);
            }
        });
        toolMenu.add(sinuositeMenuItem);

        splitLineMenuItem.setText(bundle.getString("MainFrame.splitLineMenuItem.text")); // NOI18N
        splitLineMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                splitLineMenuItemActionPerformed(evt);
            }
        });
        toolMenu.add(splitLineMenuItem);

        affectBusMenuItem.setText(bundle.getString("MainFrame.affectBusMenuItem.text")); // NOI18N
        affectBusMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                affectBusMenuItemActionPerformed(evt);
            }
        });
        toolMenu.add(affectBusMenuItem);

        mergeLinesMenuItem.setText(bundle.getString("MainFrame.mergeLinesMenuItem.text")); // NOI18N
        mergeLinesMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                mergeLinesMenuItemActionPerformed(evt);
            }
        });
        toolMenu.add(mergeLinesMenuItem);

        MenuBar.add(toolMenu);

        setJMenuBar(MenuBar);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(mapViewer, javax.swing.GroupLayout.DEFAULT_SIZE, 581, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(mapViewer, javax.swing.GroupLayout.PREFERRED_SIZE, 357, Short.MAX_VALUE)
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void loadNetMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_loadNetMenuItemActionPerformed
        LoadNetworkDialog dlg = new LoadNetworkDialog(this);
        dlg.setVisible(true);
        if(!dlg.isOk) {
            return;
        }

        try {
            String networkName = dlg.nameTextField.getText();
            String weight = dlg.weightComboBox.getSelectedItem().toString();
            String weightInd = dlg.weightIndirectComboBox.getSelectedItem().toString();
            String dirAttr = dlg.dirComboBox.getSelectedItem().toString();
            if(dirAttr.equalsIgnoreCase("(None)")) {
                dirAttr = null;
            }
            String idAttr = dlg.idComboBox.getSelectedItem().toString();
            List<DefaultFeature> edges = IOFeature.loadFeatures(dlg.netSelectFilePanel.getSelectedFile());
            WeightNetwork net = dlg.walkRadioButton.isSelected() ? 
                new WeightNetwork<>(networkName, Mode.MAP, 60) : 
                dlg.carRadioButton.isSelected() ? new WeightNetwork(networkName, Mode.VP, 60) :
                    new InterNetwork(networkName, Mode.MAP, 60);

            Object[] params = new Object[] {dirAttr, idAttr, weight, weightInd};
            
            project.addNetwork(net, dlg.netSelectFilePanel.getSelectedFile(), params);
            
            updateLayers();
            
        } catch (Exception ex) {
            Logger.getLogger(MainFrame.class.getName()).log(Level.SEVERE, null, ex);
            JOptionPane.showMessageDialog(this, "An error occured : \n" + ex.getLocalizedMessage());
        } catch(OutOfMemoryError err) {
            Logger.getLogger(MainFrame.class.getName()).log(Level.SEVERE, null, err);
            JOptionPane.showMessageDialog(this, "Not enough memory !\nIncrease memory in preferences dialog");
        } 
    }//GEN-LAST:event_loadNetMenuItemActionPerformed

    private void loadTCNetMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_loadTCNetMenuItemActionPerformed
        LoadTimeNetworkDialog dlg = new LoadTimeNetworkDialog(this);
        dlg.setVisible(true);
        if(!dlg.isOk) {
            return;
        }

        try {
            String networkName = dlg.nameTextField.getText();
            TimeTableNetwork net = new TimeTableNetwork(networkName, (Double)dlg.distCorSpinner.getValue(), (Integer)dlg.timeCorSpinner.getValue(), (Integer)dlg.dMaxSpinner.getValue());
            Object[] params;
            if(dlg.gtfSelectFilePanel.getSelectedFile() != null) {
                String epsgCode = null;
                if(!dlg.epsgCodeTextField.getText().isEmpty()) {
                    epsgCode = "EPSG:" + dlg.epsgCodeTextField.getText();
                }
                params = new Object[] {dlg.gtfSelectFilePanel.getSelectedFile().getPath(), epsgCode};
            } else {
                String nodeId = dlg.idNodeComboBox.getSelectedItem().toString();
                params = new Object[] {nodeId, dlg.dbSelectFilePanel.getSelectedFile().getPath()};
            }
            
            project.addNetwork(net, dlg.nodeSelectFilePanel.getSelectedFile(), params);
            updateLayers();        

        } catch (Exception ex) {
            Logger.getLogger(MainFrame.class.getName()).log(Level.SEVERE, null, ex);
            JOptionPane.showMessageDialog(this, "Error while loading data :\n" + ex.getLocalizedMessage());
        } catch(OutOfMemoryError err) {
            Logger.getLogger(MainFrame.class.getName()).log(Level.SEVERE, null, err);
            JOptionPane.showMessageDialog(this, "Not enough memory !\nIncrease memory in preferences dialog");
        }
    }//GEN-LAST:event_loadTCNetMenuItemActionPerformed

    private void odMatrixMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_odMatrixMenuItemActionPerformed
        final ODMatrixDialog dlg = new ODMatrixDialog(this, true);
        dlg.setVisible(true);
        if(!dlg.isOk) {
            return;
        }

        new Thread(new Runnable() {
            @Override
            public void run() {

                TreeMap<Object, Feature> origins = new TreeMap<>();
                TreeMap<Object, Feature> destinations = new TreeMap<>();

                for(NodeProperties n : project.getTotalNetwork().getNodes()) {
                    if(n.getParam() != null && n.getParam() instanceof Stop) {
                        Stop ar = (Stop)n.getParam();
                        if(dlg.nodeOrigins.contains(ar.getId().toString())) {
                            origins.put(ar.getId(), n);
                        }
                        if(dlg.nodeDestinations.contains(ar.getId().toString())) {
                            destinations.put(ar.getId(), n);
                        }
                    }
                }
                try {
                    ODMatrix mat = new ODMatrix(project.getTotalNetwork(), project.getGraph(), origins, destinations);
                    TaskMonitor monitor = new TaskMonitor(MainFrame.this, "", "", 0, 100);
                    mat.perform(dlg.minDist, dlg.start, dlg.day, dlg.period, false, monitor);

                    StringBuilder result = new StringBuilder();
                    mat.saveMatrix(result, "\t");

                    monitor.close();

                    JOptionPane.showMessageDialog(MainFrame.this, new JScrollPane(new JTextArea(result.toString(), 20, 100)));
                    
                } catch (IOException ex) {
                    Logger.getLogger(MainFrame.class.getName()).log(Level.SEVERE, null, ex);
                    JOptionPane.showMessageDialog(MainFrame.this, "An error has occured !\n" + ex.getLocalizedMessage());
                } catch(OutOfMemoryError er) {
                    Logger.getLogger(MainFrame.class.getName()).log(Level.SEVERE, null, er);
                    JOptionPane.showMessageDialog(MainFrame.this, "Not enough memory !\nTry to increase memory in preferences");
                }
            }

        }).start();
        
        
    }//GEN-LAST:event_odMatrixMenuItemActionPerformed

    private void srcPathMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_srcPathMenuItemActionPerformed
        SourcePathDialog dlg = new SourcePathDialog(this);
        dlg.setVisible(true);
    }//GEN-LAST:event_srcPathMenuItemActionPerformed

    private void prefMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_prefMenuItemActionPerformed
        PreferencesDialog dlg = new PreferencesDialog(this, true);
        dlg.setProcPanelVisible(true);
        dlg.setVisible(true);
    }//GEN-LAST:event_prefMenuItemActionPerformed

    private void pathMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_pathMenuItemActionPerformed
        PathDialog dlg = new PathDialog(this);
        dlg.setVisible(true);
    }//GEN-LAST:event_pathMenuItemActionPerformed

    private void odMatrixShpMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_odMatrixShpMenuItemActionPerformed
        final ODMatrixShpDialog dlg = new ODMatrixShpDialog(this, true);
        dlg.setVisible(true);
        if(!dlg.isOk) {
            return;
        }

        new Thread(new Runnable() {
            @Override
            public void run() {

                TreeMap<Object, Feature> origins = new TreeMap<Object, Feature>(dlg.pointOrig);
                TreeMap<Object, Feature> destinations = new TreeMap<Object, Feature>(dlg.pointDest);
                try {
                    ODMatrix mat = new ODMatrix(project.getTotalNetwork(), project.getGraph(), origins, destinations);
                    ProgressBar monitor = Config.getProgressBar("OD Matrix");
                    mat.perform(dlg.minDist, dlg.start, dlg.day, dlg.period, dlg.reverse, monitor);

                    Appendable writer;
                    String sep = "\t";
                    if(dlg.matrixFile != null) {
                        writer = new BufferedWriter(new FileWriter(dlg.matrixFile));
                        if(dlg.matrixFile.getName().toLowerCase().endsWith(".csv")) {
                            sep = ",";
                        }
                    } else {
                        writer = new StringBuilder();
                    }

                    if(dlg.pathFile != null) {
                        mat.savePaths(dlg.pathFile, monitor);
                    }
                    
                    if(dlg.tableFile != null) {
                        mat.saveTable(dlg.tableFile);
                    }
                    
                    mat.saveMatrix(writer, sep);

                    monitor.close();

                    if(dlg.matrixFile != null) {
                        ((Writer)writer).close();
                    } 
                    if(dlg.matrixFile == null && dlg.tableFile == null) {
                        JOptionPane.showMessageDialog(MainFrame.this, new JScrollPane(new JTextArea(writer.toString(), 20, 100)));
                    }

                } catch (HeadlessException | IOException | ClassNotFoundException | SQLException ex) {
                    Logger.getLogger(MainFrame.class.getName()).log(Level.SEVERE, null, ex);
                    JOptionPane.showMessageDialog(MainFrame.this, "An error has occured !\n" + ex.getLocalizedMessage());
                } catch(OutOfMemoryError er) {
                    Logger.getLogger(MainFrame.class.getName()).log(Level.SEVERE, null, er);
                    JOptionPane.showMessageDialog(MainFrame.this, "Not enough memory !\nTry to increase memory in preferences");
                }
            }


        }).start();


    }//GEN-LAST:event_odMatrixShpMenuItemActionPerformed

    private void createBDMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_createBDMenuItemActionPerformed
        BuildTimeNetworkDialog dlg = new BuildTimeNetworkDialog(this);
        dlg.setVisible(true);
        
        if(!dlg.isOk) {
            return;
        }

        try {
            String log = FusionCSV.importHoraires(dlg.dir, dlg.name);
            File dbFile = new File(dlg.dir, dlg.name + ".script");
            log += "\nDB creation completed in : " + dbFile;
            
            List<DefaultFeature> nodeFeatures = IOFeature.loadFeatures(dlg.stations);
            List<DefaultFeature> splitNodes = Tools.createStationTC(nodeFeatures, dlg.idField, dbFile);
            File stationFile = new File(dlg.dir, dlg.name + "-stations.shp");
            IOFeature.saveFeatures(splitNodes, stationFile, IOFeature.getCRS(dlg.stations));
            log += "\nStation layer created in : " + stationFile;
            
            JOptionPane.showMessageDialog(this, new JScrollPane(new JTextArea(log, 10, 50)));
        } catch (IOException | SQLException ex) {
            Logger.getLogger(MainFrame.class.getName()).log(Level.SEVERE, null, ex);
            JOptionPane.showMessageDialog(this, "An error occured :\n" + ex.getLocalizedMessage());
        }
    }//GEN-LAST:event_createBDMenuItemActionPerformed

    private void checkPartMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_checkPartMenuItemActionPerformed
        if(!project.getTotalNetwork().getNetworks().isEmpty()) {
            List<Graph> parts = GraphNetworkFactory.partition(project.getGraph());
            if(parts.size() == 1) {
                JOptionPane.showMessageDialog(this, "Only one partition");
            } else {
                List<String> attrNames = new ArrayList<>(project.getTotalNetwork().getEdges().get(0).getAttributeNames());
                attrNames.add("Component");
                List<Feature> lst = new ArrayList<>();
                int i = 1;
                for(Graph g : parts) {
                    for(Object e : g.getEdges()) {
                        Feature f = (Feature)((Edge)e).getObject();
                        List values = new ArrayList(f.getAttributes());
                        values.add(i);
                        lst.add(new DefaultFeature(f.getId(), f.getGeometry(), attrNames, values));
                    }
                    i++;
                }
                ((DefaultGroupLayer)mapViewer.getLayers()).addLayerLast(new FeatureLayer("Partitions", lst));

            }
        } else {
            try {
                File f = org.thema.common.Util.getFile(".shp|.gpkg", "Layer");
                if (f == null) {
                    return;
                }
                CLI.partitions(f);

            } catch (IOException | HeadlessException ex) {
                Logger.getLogger(MainFrame.class.getName()).log(Level.SEVERE, null, ex);
                JOptionPane.showMessageDialog(this, "An error occured :\n" + ex.getLocalizedMessage());
            }
        }
    }//GEN-LAST:event_checkPartMenuItemActionPerformed

    private void sinuositeMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_sinuositeMenuItemActionPerformed
        File f = org.thema.common.Util.getFile(".shp|.gpkg", "Layer");
        if(f == null) {
            return;
        }
        try {
            List<DefaultFeature> features = IOFeature.loadFeatures(f);
            Tools.calcSinuosity(features, project.getGraphFactory().getReducer());
            IOFeature.saveFeatures(features, new File(f.getParentFile(), f.getName().substring(0, f.getName().lastIndexOf(".")) + "-sin.gpkg"),
                            IOFeature.getCRS(f));
            JOptionPane.showMessageDialog(this, "Layer saved.");
        } catch (IOException ex) {
            Logger.getLogger(MainFrame.class.getName()).log(Level.SEVERE, null, ex);
            JOptionPane.showMessageDialog(this, "An error occured :\n" + ex.getLocalizedMessage());
        }

    }//GEN-LAST:event_sinuositeMenuItemActionPerformed

    private void splitLineMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_splitLineMenuItemActionPerformed
        File f = org.thema.common.Util.getFile(".shp|.gpkg", "Layer");
        if(f == null) {
            return;
        }
        try {
            List<DefaultFeature> features = IOFeature.loadFeatures(f);
            features = Tools.splitLineAtIntersect(features);
            IOFeature.saveFeatures(features, new File(f.getParentFile(), f.getName().substring(0, f.getName().lastIndexOf(".")) + "-split.gpkg"),
                            IOFeature.getCRS(f));
        } catch (IOException ex) {
            Logger.getLogger(MainFrame.class.getName()).log(Level.SEVERE, null, ex);
            JOptionPane.showMessageDialog(this, "An error occured :\n" + ex.getLocalizedMessage());
        }

    }//GEN-LAST:event_splitLineMenuItemActionPerformed

    private void checkAllPathMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_checkAllPathMenuItemActionPerformed
        new Thread(new Runnable() {
            @Override
            public void run() {
                List<Feature> lines = Tools.checkAllPaths(project.getGraph(), project.getTotalNetwork());
                if(lines.size() > 0) {
                    ((DefaultGroupLayer)mapViewer.getLayers()).addLayerFirst(new FeatureLayer("No path found", lines));
                } else {
                    JOptionPane.showMessageDialog(MainFrame.this, "All path exist");
                }
            }
        }).start();

    }//GEN-LAST:event_checkAllPathMenuItemActionPerformed

    private void affectBusMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_affectBusMenuItemActionPerformed
        Collection<AbstractNetwork> networks = project.getTotalNetwork().getNetworks();
        if(networks.size() != 1 || !(networks.iterator().next() instanceof TimeTableNetwork)) {
            JOptionPane.showMessageDialog(this, "Only for one time table network");
            return;
        }
        File f = Util.getFile(".shp|.gpkg", "Layer");
        if(f == null) {
            return;
        }
        try {
            List<DefaultFeature> lines = IOFeature.loadFeatures(f);
            String res = Tools.affectBus((TimeTableNetwork)networks.iterator().next(), lines);

            JOptionPane.showMessageDialog(this, new JScrollPane(new JTextArea(res, 30, 100)));
        } catch (IOException ex) {
            Logger.getLogger(MainFrame.class.getName()).log(Level.SEVERE, null, ex);
            JOptionPane.showMessageDialog(this, "Error while loading data : \n" + ex.getLocalizedMessage());
        }

    }//GEN-LAST:event_affectBusMenuItemActionPerformed

    private void createBDStationMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_createBDStationMenuItemActionPerformed
        JFileChooser dlg = new JFileChooser();
        dlg.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
        if(dlg.showOpenDialog(this) != JFileChooser.APPROVE_OPTION) {
            return;
        }
        File dir = dlg.getSelectedFile();

        try {
            String log = FusionCSVStation.importHoraires(dir);
            log += "\nDB creation completed.";
            JOptionPane.showMessageDialog(this, new JScrollPane(new JTextArea(log, 10, 50)));
        } catch (IOException | SQLException | HeadlessException ex) {
            Logger.getLogger(MainFrame.class.getName()).log(Level.SEVERE, null, ex);
            JOptionPane.showMessageDialog(this, "An error occured :\n" + ex.getLocalizedMessage());
        }
    }//GEN-LAST:event_createBDStationMenuItemActionPerformed

    private void checkTCNetMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_checkTCNetMenuItemActionPerformed
        LoadTimeNetworkDialog dlg = new LoadTimeNetworkDialog(this);
        dlg.setVisible(true);
        if(!dlg.isOk) {
            return;
        }

        try {
            String networkName = dlg.nameTextField.getText();
            List<DefaultFeature> nodeFeatures = IOFeature.loadFeatures(dlg.nodeSelectFilePanel.getSelectedFile());
            TimeTableNetwork net = new TimeTableNetwork(networkName, (Double)dlg.distCorSpinner.getValue(), 0, 0);
            String nodeId = dlg.idNodeComboBox.getSelectedItem().toString();

            String log = Tools.checkTCNetwork(net, nodeFeatures, nodeId, dlg.dbSelectFilePanel.getSelectedFile());

            JOptionPane.showMessageDialog(this, new JScrollPane(new JTextArea(log, 10, 50)));

        } catch (Exception ex) {
            Logger.getLogger(MainFrame.class.getName()).log(Level.SEVERE, null, ex);
            JOptionPane.showMessageDialog(this, "Error while loading data :\n" + ex.getLocalizedMessage());
        } catch(OutOfMemoryError err) {
            JOptionPane.showMessageDialog(this, "Not enough memory !\nIncrease memory in preferences dialog");
        }
    }//GEN-LAST:event_checkTCNetMenuItemActionPerformed

    private void mergeLinesMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_mergeLinesMenuItemActionPerformed
        File f = org.thema.common.Util.getFile(".shp|.gpkg", "Layer");
        if(f == null) {
            return;
        }
        try {
            List<DefaultFeature> features = IOFeature.loadFeatures(f);
            features = Tools.mergeLines(features, project.getGraphFactory().getReducer());
            IOFeature.saveFeatures(features, new File(f.getParentFile(), f.getName().substring(0, f.getName().lastIndexOf(".")) + "-merge.gpkg"),
                            IOFeature.getCRS(f));
            JOptionPane.showMessageDialog(this, "Layer saved.");
        } catch (IOException ex) {
            Logger.getLogger(MainFrame.class.getName()).log(Level.SEVERE, null, ex);
            JOptionPane.showMessageDialog(this, "An error occured :\n" + ex.getLocalizedMessage());
        }
    }//GEN-LAST:event_mergeLinesMenuItemActionPerformed

    private void loadProjectjMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_loadProjectjMenuItemActionPerformed
        File f = Util.getFile(".xml", "Project file");
        if(f == null) {
            return;
        }
        updateLayers();
        try {
            project = Project.load(f);
            updateLayers();
        } catch (Exception ex) {
            throw new RuntimeException(ex);
        }
        
        
    }//GEN-LAST:event_loadProjectjMenuItemActionPerformed

    private void saveProjectMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_saveProjectMenuItemActionPerformed
        File f = Util.getFileSave(".xml");
        if(f == null) {
            return;
        }

        try {
            project.saveProject(f);
        } catch (IOException ex) {
            throw new RuntimeException(ex);
        }
    }//GEN-LAST:event_saveProjectMenuItemActionPerformed
    
    private void nearestResMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_nearestResMenuItemActionPerformed
        final NearestRessouceDialog dlg = new NearestRessouceDialog(this, true);
        dlg.setVisible(true);
        if(!dlg.isOk) {
            return;
        }
        final ProgressBar progress = Config.getProgressBar("Nearest ressource", 2*dlg.points.size());
        new Thread(new Runnable() {
            @Override
            public void run() {
                Map<Coordinate, Double> minTime = new HashMap<>();
                Map<Coordinate, Object> nearestRes = new HashMap<>();
                List<DefaultFeature> origins = null;
                if(dlg.origins != null) {
                    try {
                        origins = IOFeature.loadFeatures(dlg.origins);
                    } catch (IOException ex) {
                        throw new RuntimeException(ex);
                    }
                }
                Envelope envelope = new Envelope();
                for(Feature res : dlg.points) {
                    List<NetworkLocation> locs = project.getTotalNetwork().getLocations(res);
                    NetworkPathFinder pathfinder;
                    if(!dlg.reverse) {
                        pathfinder = new DijkstraNetworkPathFinder(locs,
                                new DefaultWeighter(), DayTime.getTotalTime(dlg.start, dlg.day));
                    } else {
                        pathfinder = new ReverseDijkstraNetworkPathFinder(locs,
                                new DefaultWeighter(), DayTime.getTotalTime(dlg.start, dlg.day));
                    }
                    pathfinder.calculate();

                    if(origins == null) {
                        for(NodeProperties node : project.getTotalNetwork().getNodes()) {
                            Double t = pathfinder.getCost(node.getNode());
                            if(t == null) {
                                continue;
                            }
                            Coordinate c = node.getPoint().getCoordinate();
                            if(!minTime.containsKey(c) || 
                                    t < minTime.get(c)) {
                                minTime.put(c, t);
                                nearestRes.put(c, res.getId());
                                envelope.expandToInclude(c);
                            }
                        }
                    } else {
                        for(DefaultFeature orig : origins) {
                            Double t = pathfinder.getBestCost(project.getTotalNetwork().getLocations(orig));
                            if(t == null) {
                                continue;
                            }
                            Coordinate c = orig.getGeometry().getCentroid().getCoordinate();
                            if(!minTime.containsKey(c) || 
                                    t < minTime.get(c)) {
                                minTime.put(c, t);
                                nearestRes.put(c, res.getId());
                                envelope.expandToInclude(c);
                            }
                        }
                    }
                    progress.incProgress(1);
                }

                VoronoiDiagramBuilder voronoiBuilder = new VoronoiDiagramBuilder();
                voronoiBuilder.setSites(minTime.keySet());
                envelope.expandBy(envelope.getWidth()/10, envelope.getHeight()/10);
                voronoiBuilder.setClipEnvelope(envelope);
                Geometry voronoi = voronoiBuilder.getDiagram(new GeometryFactory());
                HashMapList<Object, Polygon> polygons = new HashMapList<>();
                HashMap<Object, SummaryStatistics> stats = new HashMap<>();
                for(int i = 0; i < voronoi.getNumGeometries(); i++) {
                    Polygon p = (Polygon)voronoi.getGeometryN(i);
                    Object id = nearestRes.get((Coordinate)p.getUserData());
                    polygons.putValue(id, p);
                    if(!stats.containsKey(id)) {
                        stats.put(id, new SummaryStatistics());
                    }
                    stats.get(id).addValue(minTime.get((Coordinate)p.getUserData()) / DayTime.MINUTE);
                }

                List<DefaultFeature> nearestZones = new ArrayList<>();
                List<String> attrs = Arrays.asList("nb", "min", "avg", "max");
                for(Object id : polygons.keySet()) {
                    Geometry zone = CascadedPolygonUnion.union(polygons.get(id));
                    SummaryStatistics stat = stats.get(id);
                    nearestZones.add(new DefaultFeature(id, zone, attrs, Arrays.asList(stat.getN(), stat.getMin(), stat.getMean(), stat.getMax())));
                    progress.incProgress(1);
                }

                if(origins != null) {
                    DefaultFeature.addAttribute("IdRess", origins, "");
                    DefaultFeature.addAttribute("DistRess", origins, -1.0);
                    for(DefaultFeature orig : origins) {
                        Coordinate c = orig.getGeometry().getCentroid().getCoordinate();
                        orig.setAttribute("DistRess", minTime.get(c) / DayTime.MINUTE);
                        orig.setAttribute("IdRess", nearestRes.get(c));                       
                    }
                    
                }
                DefaultGroupLayer gl = new DefaultGroupLayer("Nearest ressource", true);
                gl.setRemovable(true);
                PointStyle pointStyle = new PointStyle();
                pointStyle.setAttrLabel(FeatureStyle.ID_ATTR);
                gl.addLayerFirst(new FeatureLayer("Ressources", dlg.points, pointStyle));
                gl.addLayerLast(new FeatureLayer("Zones", nearestZones, new FeatureStyle(new Color(0, 0, 0, 50), Color.BLACK)));
                if(origins != null) {
                    gl.addLayerFirst(new FeatureLayer("Origins", origins, new PointStyle()));
                }
                ((DefaultGroupLayer)mapViewer.getLayers()).addLayerFirst(gl);
                
                progress.close();
            }
        }).start();
        
    }//GEN-LAST:event_nearestResMenuItemActionPerformed


    public Project getProject() {
        return project;
    }
    
    private void updateLayers() {
        
        DefaultGroupLayer glayer = new DefaultGroupLayer("Layers", true);
        for(AbstractNetwork net : project.getTotalNetwork().getNetworks()) {
            DefaultGroupLayer gl = new DefaultGroupLayer(net.getName()) {
                @Override
                public JPopupMenu getContextMenu() {
                    JPopupMenu menu = super.getContextMenu(); 
                    if(menu == null) {
                        menu = new JPopupMenu();
                    }
                    menu.add(new AbstractAction("Remove") {
                        @Override
                        public void actionPerformed(ActionEvent e) {
                            int res = JOptionPane.showConfirmDialog(null, "Do you want to remove network " + getName(), "Remove network", JOptionPane.YES_NO_OPTION);
                            if(res == JOptionPane.YES_OPTION) {
                                try {
                                    project.removeNetwork(getName());
                                    updateLayers();
                                } catch (Exception ex) {
                                    throw new RuntimeException(ex);
                                }
                            }
                        }
                    });
                    return menu;
                }
                
            };
            gl.addLayerFirst(new FeatureLayer(net.getName() + "- edges", net.getEdges()));
            Layer l = new FeatureLayer(net.getName() + "- nodes", net.getNodes());
            l.setVisible(false);
            gl.addLayerFirst(l);
            glayer.addLayerLast(gl);

        }
        Layer l = new GraphLayer("Graph", project.getGraph());
        l.setVisible(false);
        glayer.addLayerFirst(l);
        mapViewer.setRootLayer(glayer);
    }
    
    /**
    * @param args the command line arguments
    */
    public static void main(String args[]) throws Exception {
        // CLI execution
        if(args.length > 0 && !args[0].equals(JavaLoader.NOFORK)) {
            if(!GraphicsEnvironment.isHeadless() && SplashScreen.getSplashScreen() != null) {
                SplashScreen.getSplashScreen().close();
            }
            CLI.execute(args);
            
            return;
        }
        
        Config.setNodeClass(MainFrame.class);
        PreferencesDialog.initLanguage();

        JavaLoader.launchGUI(MainFrame.class, args.length == 0, 1024);
        
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JMenuBar MenuBar;
    private javax.swing.JMenuItem affectBusMenuItem;
    private javax.swing.JMenuItem checkAllPathMenuItem;
    private javax.swing.JMenuItem checkPartMenuItem;
    private javax.swing.JMenuItem checkTCNetMenuItem;
    private javax.swing.JMenuItem createBDMenuItem;
    private javax.swing.JMenuItem createBDStationMenuItem;
    private javax.swing.JMenu fileMenu;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JPopupMenu.Separator jSeparator2;
    private javax.swing.JPopupMenu.Separator jSeparator3;
    private javax.swing.JMenuItem loadNetMenuItem;
    private javax.swing.JMenuItem loadProjectjMenuItem;
    private javax.swing.JMenuItem loadTCNetMenuItem;
    private org.thema.drawshape.ui.MapViewer mapViewer;
    private javax.swing.JMenuItem mergeLinesMenuItem;
    private javax.swing.JMenuItem nearestResMenuItem;
    private javax.swing.JMenuItem odMatrixMenuItem;
    private javax.swing.JMenuItem odMatrixShpMenuItem;
    private javax.swing.JMenu pathMenu;
    private javax.swing.JMenuItem pathMenuItem;
    private javax.swing.JMenuItem prefMenuItem;
    private javax.swing.JMenuItem saveProjectMenuItem;
    private javax.swing.JMenuItem sinuositeMenuItem;
    private javax.swing.JMenuItem splitLineMenuItem;
    private javax.swing.JMenuItem srcPathMenuItem;
    private javax.swing.JMenu toolMenu;
    // End of variables declaration//GEN-END:variables

}
